# Damien Leroy - UCLouvain
# June, 2008

import SOAPpy
from Prefix import Prefix
import os
from ConfigParser import *
import ConfigGen

config = SafeConfigParser()
config.read("updactions.conf")

def do(action, prefixlist):
	
	if not config.has_section(action) : 
		print "Error: Nothing defined for the action requested: "+action
		return 0 
	
	
	# prepare the prefix list : 
	objprefixes = [ ]
	for p in prefixlist :
		newpref = Prefix()
		newpref.recover(p)
		objprefixes.append(newpref)
	
	#pre:
	try: 
		i = 1
		while ( True ) : 
			os.system(config.get(action, "pre-"+str(i)))
			i+=1
	except NoOptionError : pass
				

	#upd: (format: "upd-1:/path/to/abstract/file,/path/to/dst")
	try: 
		i = 1
		while ( True ) : 
			updates = config.get(action, "upd-"+str(i))
			updtab = updates.split(",")
			if len(updtab) != 2 : continue
			ConfigGen.convert(updtab[0], updtab[1], objprefixes)
			i+=1
	except NoOptionError : pass

	
	#post
	try: 
		i = 1
		while ( True ) : 
			os.system(config.get(action, "post-"+str(i)))
			i+=1
	except NoOptionError : pass
	
	print "Update "+action+" completed"
	
	return 1
	
#def act(action, param):
#
#    try :
#        return {
#               "ns_conf" : PrefixUpdater.update_bind_config
#               
#               }[action](param)
#               
#    except KeyError:
#        return 0
#        


try: 
    print "-- Launching daemon --"
    server = SOAPpy.SOAPServer(("130.104.228.58", 9876))
    server.registerFunction(do)
    server.serve_forever()

except KeyboardInterrupt:
    print "-- Server Stopped --"

except Exception,msg :
    print "Error: ",msg[1]

