# Damien Leroy - UCLouvain
# June, 2008

import sys, os, re, string

''' Search and replace the regx from src file to dst file '''
def regexfile(srcfile, dstfile, searchregx, replacestring):

    # compile regexp
    cregex=re.compile(searchregx)

    # open file for read  
    inputfile = open(srcfile,'r')
    readlines=inputfile.readlines()

    # open the file for writting  
    write_file=open(dstfile,'w') 

    # search and replace in current file printing to the user changed lines
    for currentline in readlines:

        # make the substitution
        currentline = re.sub(searchregx,replacestring,currentline)
        
        # write in the output file  
        write_file.write(currentline)

    # close the file
    write_file.close()
    inputfile.close()

if __name__ == '__main__':
       
    regexfile(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
